require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__ASM_ARM_PTRACE_H)) {
    eval 'sub __ASM_ARM_PTRACE_H () {1;}' unless defined(&__ASM_ARM_PTRACE_H);
    require 'asm/hwcap.ph';
    eval 'sub PTRACE_GETREGS () {12;}' unless defined(&PTRACE_GETREGS);
    eval 'sub PTRACE_SETREGS () {13;}' unless defined(&PTRACE_SETREGS);
    eval 'sub PTRACE_GETFPREGS () {14;}' unless defined(&PTRACE_GETFPREGS);
    eval 'sub PTRACE_SETFPREGS () {15;}' unless defined(&PTRACE_SETFPREGS);
    eval 'sub PTRACE_GETWMMXREGS () {18;}' unless defined(&PTRACE_GETWMMXREGS);
    eval 'sub PTRACE_SETWMMXREGS () {19;}' unless defined(&PTRACE_SETWMMXREGS);
    eval 'sub PTRACE_OLDSETOPTIONS () {21;}' unless defined(&PTRACE_OLDSETOPTIONS);
    eval 'sub PTRACE_GET_THREAD_AREA () {22;}' unless defined(&PTRACE_GET_THREAD_AREA);
    eval 'sub PTRACE_SET_SYSCALL () {23;}' unless defined(&PTRACE_SET_SYSCALL);
    eval 'sub PTRACE_GETCRUNCHREGS () {25;}' unless defined(&PTRACE_GETCRUNCHREGS);
    eval 'sub PTRACE_SETCRUNCHREGS () {26;}' unless defined(&PTRACE_SETCRUNCHREGS);
    eval 'sub PTRACE_GETVFPREGS () {27;}' unless defined(&PTRACE_GETVFPREGS);
    eval 'sub PTRACE_SETVFPREGS () {28;}' unless defined(&PTRACE_SETVFPREGS);
    eval 'sub PTRACE_GETHBPREGS () {29;}' unless defined(&PTRACE_GETHBPREGS);
    eval 'sub PTRACE_SETHBPREGS () {30;}' unless defined(&PTRACE_SETHBPREGS);
    eval 'sub PTRACE_GETFDPIC () {31;}' unless defined(&PTRACE_GETFDPIC);
    eval 'sub PTRACE_GETFDPIC_EXEC () {0;}' unless defined(&PTRACE_GETFDPIC_EXEC);
    eval 'sub PTRACE_GETFDPIC_INTERP () {1;}' unless defined(&PTRACE_GETFDPIC_INTERP);
    eval 'sub USR26_MODE () {0x;}' unless defined(&USR26_MODE);
    eval 'sub FIQ26_MODE () {0x1;}' unless defined(&FIQ26_MODE);
    eval 'sub IRQ26_MODE () {0x2;}' unless defined(&IRQ26_MODE);
    eval 'sub SVC26_MODE () {0x3;}' unless defined(&SVC26_MODE);
    eval 'sub USR_MODE () {0x10;}' unless defined(&USR_MODE);
    eval 'sub SVC_MODE () {0x13;}' unless defined(&SVC_MODE);
    eval 'sub FIQ_MODE () {0x11;}' unless defined(&FIQ_MODE);
    eval 'sub IRQ_MODE () {0x12;}' unless defined(&IRQ_MODE);
    eval 'sub MON_MODE () {0x16;}' unless defined(&MON_MODE);
    eval 'sub ABT_MODE () {0x17;}' unless defined(&ABT_MODE);
    eval 'sub HYP_MODE () {0x1a;}' unless defined(&HYP_MODE);
    eval 'sub UND_MODE () {0x1b;}' unless defined(&UND_MODE);
    eval 'sub SYSTEM_MODE () {0x1f;}' unless defined(&SYSTEM_MODE);
    eval 'sub MODE32_BIT () {0x10;}' unless defined(&MODE32_BIT);
    eval 'sub MODE_MASK () {0x1f;}' unless defined(&MODE_MASK);
    eval 'sub V4_PSR_T_BIT () {0x20;}' unless defined(&V4_PSR_T_BIT);
    eval 'sub V7M_PSR_T_BIT () {0x1000000;}' unless defined(&V7M_PSR_T_BIT);
    eval 'sub PSR_T_BIT () { &V4_PSR_T_BIT;}' unless defined(&PSR_T_BIT);
    eval 'sub PSR_F_BIT () {0x40;}' unless defined(&PSR_F_BIT);
    eval 'sub PSR_I_BIT () {0x80;}' unless defined(&PSR_I_BIT);
    eval 'sub PSR_A_BIT () {0x100;}' unless defined(&PSR_A_BIT);
    eval 'sub PSR_E_BIT () {0x200;}' unless defined(&PSR_E_BIT);
    eval 'sub PSR_J_BIT () {0x1000000;}' unless defined(&PSR_J_BIT);
    eval 'sub PSR_Q_BIT () {0x8000000;}' unless defined(&PSR_Q_BIT);
    eval 'sub PSR_V_BIT () {0x10000000;}' unless defined(&PSR_V_BIT);
    eval 'sub PSR_C_BIT () {0x20000000;}' unless defined(&PSR_C_BIT);
    eval 'sub PSR_Z_BIT () {0x40000000;}' unless defined(&PSR_Z_BIT);
    eval 'sub PSR_N_BIT () {0x80000000;}' unless defined(&PSR_N_BIT);
    eval 'sub PSR_f () {0xff000000;}' unless defined(&PSR_f);
    eval 'sub PSR_s () {0xff0000;}' unless defined(&PSR_s);
    eval 'sub PSR_x () {0xff00;}' unless defined(&PSR_x);
    eval 'sub PSR_c () {0xff;}' unless defined(&PSR_c);
    eval 'sub APSR_MASK () {0xf80f0000;}' unless defined(&APSR_MASK);
    eval 'sub PSR_ISET_MASK () {0x1000010;}' unless defined(&PSR_ISET_MASK);
    eval 'sub PSR_IT_MASK () {0x600fc00;}' unless defined(&PSR_IT_MASK);
    eval 'sub PSR_ENDIAN_MASK () {0x200;}' unless defined(&PSR_ENDIAN_MASK);
    if(defined(&CONFIG_CPU_ENDIAN_BE8)) {
	eval 'sub PSR_ENDSTATE () { &PSR_E_BIT;}' unless defined(&PSR_ENDSTATE);
    } else {
	eval 'sub PSR_ENDSTATE () {0;}' unless defined(&PSR_ENDSTATE);
    }
    eval 'sub PT_TEXT_ADDR () {0x10000;}' unless defined(&PT_TEXT_ADDR);
    eval 'sub PT_DATA_ADDR () {0x10004;}' unless defined(&PT_DATA_ADDR);
    eval 'sub PT_TEXT_END_ADDR () {0x10008;}' unless defined(&PT_TEXT_END_ADDR);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub ARM_cpsr () { $uregs[16];}' unless defined(&ARM_cpsr);
	eval 'sub ARM_pc () { $uregs[15];}' unless defined(&ARM_pc);
	eval 'sub ARM_lr () { $uregs[14];}' unless defined(&ARM_lr);
	eval 'sub ARM_sp () { $uregs[13];}' unless defined(&ARM_sp);
	eval 'sub ARM_ip () { $uregs[12];}' unless defined(&ARM_ip);
	eval 'sub ARM_fp () { $uregs[11];}' unless defined(&ARM_fp);
	eval 'sub ARM_r10 () { $uregs[10];}' unless defined(&ARM_r10);
	eval 'sub ARM_r9 () { $uregs[9];}' unless defined(&ARM_r9);
	eval 'sub ARM_r8 () { $uregs[8];}' unless defined(&ARM_r8);
	eval 'sub ARM_r7 () { $uregs[7];}' unless defined(&ARM_r7);
	eval 'sub ARM_r6 () { $uregs[6];}' unless defined(&ARM_r6);
	eval 'sub ARM_r5 () { $uregs[5];}' unless defined(&ARM_r5);
	eval 'sub ARM_r4 () { $uregs[4];}' unless defined(&ARM_r4);
	eval 'sub ARM_r3 () { $uregs[3];}' unless defined(&ARM_r3);
	eval 'sub ARM_r2 () { $uregs[2];}' unless defined(&ARM_r2);
	eval 'sub ARM_r1 () { $uregs[1];}' unless defined(&ARM_r1);
	eval 'sub ARM_r0 () { $uregs[0];}' unless defined(&ARM_r0);
	eval 'sub ARM_ORIG_r0 () { $uregs[17];}' unless defined(&ARM_ORIG_r0);
	eval 'sub ARM_VFPREGS_SIZE () {( 32* 8+ 4);}' unless defined(&ARM_VFPREGS_SIZE);
    }
}
1;
